@echo off
@rem Copyright 2011-2012 FUJITSU LIMITED

setlocal

@rem Main
@rem args none

@rem Find the installation directory.
@rem ROR V3.0
if defined RCXCFMG_HOME (
  set SWCFMG_MWTMP_INSTALL_HOME=%RCXCFMG_HOME%
  set SWCFMG_MWTMP_INSTALL_VERSION=2
  goto FIND_INSTALL_DIR
)
@rem CF-MG V14.1
reg query "HKLM\SOFTWARE\Wow6432Node\Fujitsu\SystemwalkerCF-MG\14.1.0" /v "Directory" >NUL 2>&1
if not %ERRORLEVEL% == 0 (
  echo ERROR: INS00001: Failed to find the installation directory. 1>&2
  goto ERROR_1_END
)
for /f "tokens=1,2*" %%A in ('reg query "HKLM\SOFTWARE\Wow6432Node\Fujitsu\SystemwalkerCF-MG\14.1.0" /v "Directory"') do set SWCFMG_MWTMP_INSTALL_HOME=%%C
set SWCFMG_MWTMP_INSTALL_VERSION=1

:FIND_INSTALL_DIR
set SWCFMG_MWTMP_INSTALL_DIR=%~dp0
if not "%SWCFMG_MWTMP_INSTALL_DIR:~-1%" == "\" (
  set SWCFMG_MWTMP_INSTALL_DIR=%SWCFMG_MWTMP_INSTALL_DIR%\
)

@rem Register the software setup information.
call :METHOD_REGIST_SOFTSETUP  IBPMA\cmd\softwaresetup_ibpma_cmd.xml RS00000300 IBPMA\cmd\setupscript_ibpma_cmd.zip
if not %ERRORLEVEL% == 0 (goto ERROR_2_END)
call :METHOD_REGIST_SOFTSETUP  IBPMA\sh\softwaresetup_ibpma_sh.xml   RS00000301 IBPMA\sh\setupscript_ibpma_sh.zip
if not %ERRORLEVEL% == 0 (goto ERROR_2_END)
call :METHOD_REGIST_SOFTSETUP  ISI\cmd\softwaresetup_isi_cmd.xml     RS00000500 ISI\cmd\setupscript_isi_cmd.zip
if not %ERRORLEVEL% == 0 (goto ERROR_2_END)
call :METHOD_REGIST_SOFTSETUP  ISI\sh\softwaresetup_isi_sh.xml       RS00000501 ISI\sh\setupscript_isi_sh.zip
if not %ERRORLEVEL% == 0 (goto ERROR_2_END)

@rem Copy the software information.
call :METHOD_COPY_SOFT_FILE  LC-CO_9.2.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  LC-CO_9.2.0_WIN64.xml
call :METHOD_COPY_SOFT_FILE  LC-CO_9.1.0_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  IBPMA_11.1.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  IBPMA_11.1.0_WIN64.xml
call :METHOD_COPY_SOFT_FILE  IBPMA_11.1.0_LINUX.xml
call :METHOD_COPY_SOFT_FILE  IBPMA_11.1.0_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  IIM_9.1.1_WIN.xml
call :METHOD_COPY_SOFT_FILE  IIM_9.1.1_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_9.3.1_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_9.3.1_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_9.3.1_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_9.3.1_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_10.0.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_10.0.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_10.0.0_WIN64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_10.0.0_WIN64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_10.0.0_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_10.0.0_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_10.0.0_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_10.0.0_LINUX64.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_SJE_10.1.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_EE_10.1.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_WEB_10.0.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_WEB_10.0.0_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISAPS_WEB_10.1.0_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISI_SE_9.2_WIN.xml
call :METHOD_COPY_SOFT_FILE  ISI_SE_9.2_WIN64.xml
call :METHOD_COPY_SOFT_FILE  ISI_SE_9.2_LINUX.xml
call :METHOD_COPY_SOFT_FILE  ISI_SE_9.2_LINUX64.xml


@rem Copy the tool files.
call :METHOD_COPY_TOOL_FILE

@rem Normal end
:NORMAL_END
endlocal
exit /B 0

@rem Error 1 end
:ERROR_1_END
endlocal
exit /B 1

@REM Error 2 end
:ERROR_2_END
endlocal
exit /B 2


@rem Method that register the software setup information.
@rem args
@rem %1 software setup information file
@rem %2 software setup id
@rem %3 script package file
:METHOD_REGIST_SOFTSETUP

if "%SWCFMG_MWTMP_INSTALL_VERSION%" == "1" (
  set SWCFMG_SOFTSETUPINFO_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwareSetups_1.0\%1
  set SWCFMG_SCRIPTPKG_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwareSetups_1.0\%3
) else (
  set SWCFMG_SOFTSETUPINFO_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwareSetups_2.0\%1
  set SWCFMG_SCRIPTPKG_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwareSetups_2.0\%3
)
"%SWCFMG_MWTMP_INSTALL_HOME%\bin\cfmg_updatesoftsetup" -force -xml "%SWCFMG_SOFTSETUPINFO_FILE%"
if not %ERRORLEVEL% == 0 (
  echo --
  echo ERROR: INS00002: Failed to register the software setup information. [file=%1] 1>&2
  exit /B 1
)
"%SWCFMG_MWTMP_INSTALL_HOME%\bin\cfmg_uploadpackage" -force -id %2 -pkg "%SWCFMG_SCRIPTPKG_FILE%"
if not %ERRORLEVEL% == 0 (
  echo --
  echo ERROR: INS00003: Failed to register the script package. [id=%2, file=%3] 1>&2
  exit /B 2
)
exit /B 0

@rem Method that copy the software information file.
@rem args
@rem %1 target file
:METHOD_COPY_SOFT_FILE

if "%SWCFMG_MWTMP_INSTALL_VERSION%" == "1" (
  set SWCFMG_COPY_SOURCE_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwares_1.1\%1
) else (
  set SWCFMG_COPY_SOURCE_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softwares_2.0\%1
)
set SWCFMG_COPY_DESTINATION_FILE=%SWCFMG_MWTMP_INSTALL_HOME%\templates\softwares\%1
if exist "%SWCFMG_COPY_DESTINATION_FILE%" (
   echo WARNING: INS00005: The software information file already exists. [file=%SWCFMG_COPY_DESTINATION_FILE%] 1>&2
   exit /B 0
)
copy "%SWCFMG_COPY_SOURCE_FILE%" "%SWCFMG_COPY_DESTINATION_FILE%" >NUL 2>&1
if not %ERRORLEVEL% == 0 (
  echo WARNING: INS00004: Failed to copy of the software information. [file=%SWCFMG_COPY_DESTINATION_FILE%] 1>&2
)
exit /B 0

@rem Method that copy the tool files.
@rem args none
:METHOD_COPY_TOOL_FILE

set SWCFMG_COPY_SOURCE_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softtools\windows\aps9
set SWCFMG_COPY_DESTINATION_FILE=%SWCFMG_MWTMP_INSTALL_HOME%\softtools\windows\aps9
copy /Y "%SWCFMG_COPY_SOURCE_FILE%" "%SWCFMG_COPY_DESTINATION_FILE%" >NUL 2>&1
if not %ERRORLEVEL% == 0 (
   echo WARNING: INS00006: Failed to copy of the tool files. [file=%SWCFMG_COPY_DESTINATION_FILE%] 1>&2
)
set SWCFMG_COPY_SOURCE_FILE=%SWCFMG_MWTMP_INSTALL_DIR%softtools\linux\aps9
set SWCFMG_COPY_DESTINATION_FILE=%SWCFMG_MWTMP_INSTALL_HOME%\softtools\linux\aps9
copy /Y "%SWCFMG_COPY_SOURCE_FILE%" "%SWCFMG_COPY_DESTINATION_FILE%" >NUL 2>&1
if not %ERRORLEVEL% == 0 (
   echo WARNING: INS00006: Failed to copy of the tool files. [file=%SWCFMG_COPY_DESTINATION_FILE%] 1>&2
)
exit /B 0
